/*
 Vocoder               SCY/.tSCc.
   26.02.99
*/

#ifndef __COMMON_H__
#define __COMMON_H__

#define VERSION "0.5.14"
#define VERSIONDATE "31.07.99"

// Includes /*fold00*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef LINUX
#include <unistd.h>
#endif

// Defines /*fold00*/
#define USE(x) x=x;

#ifdef LINUX
#define DEBUG_PRINTF(format,args...) printf(format,##args);
#define ERR_PRINTF(format,args...) fprintf(stderr,"ERROR: "format,##args);
#define WARN_PRINTF(format,args...) fprintf(stderr,"warning: "format,##args);
#else
#define DEBUG_PRINTF(format) printf(format);
#define ERR_PRINTF(format) fprintf(stderr,"ERROR: "format);
#define WARN_PRINTF(format) fprintf(stderr,"warning: "format);
#endif

// Globals /*fold00*/
extern int errno;
enum soundmode_t{
   SOUND_OFF,
   SOUND_PLAY,
   SOUND_PAUSE
};
extern enum soundmode_t soundmode;


// Errorcodes /*fold00*/

// no data currently available
#define ERR_NODATA      0
// system error; see errno for details
#define ERR_SYSTEM     -1
// unspecified error
#define ERR_UNSPEC     -2
// end of data
#define ERR_EOF        -3
// error in commandline
#define ERR_CMDLINE    -4

// typedefs, structs /*fold00*/
typedef double Sample;


#endif /*FOLD00*/
